import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'trip_overlay_plugin_method_channel.dart';

abstract class TripOverlayPluginPlatform extends PlatformInterface {
  /// Constructs a TripOverlayPluginPlatform.
  TripOverlayPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static TripOverlayPluginPlatform _instance = MethodChannelTripOverlayPlugin();

  /// The default instance of [TripOverlayPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelTripOverlayPlugin].
  static TripOverlayPluginPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [TripOverlayPluginPlatform] when
  /// they register themselves.
  static set instance(TripOverlayPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
